diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/mesh/model/dot11s/peer-management-protocol.cc ns-3.41/src/mesh/model/dot11s/peer-management-protocol.cc
--- ns-3.40/src/mesh/model/dot11s/peer-management-protocol.cc	2023-09-27 13:30:37.834839600 -0700
+++ ns-3.41/src/mesh/model/dot11s/peer-management-protocol.cc	2024-02-09 14:44:08.357793300 -0800
@@ -336,7 +336,7 @@
             }
             else
             {
-                return (*i);
+                return *i;
             }
         }
     }
@@ -390,7 +390,7 @@
     Ptr<PeerLink> peerLink = FindPeerLink(interface, peerAddress);
     if (peerLink)
     {
-        return (peerLink->LinkIsEstab());
+        return peerLink->LinkIsEstab();
     }
     return false;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/mesh/model/dot11s/peer-management-protocol-mac.cc ns-3.41/src/mesh/model/dot11s/peer-management-protocol-mac.cc
--- ns-3.40/src/mesh/model/dot11s/peer-management-protocol-mac.cc	2023-09-27 13:30:37.834839600 -0700
+++ ns-3.41/src/mesh/model/dot11s/peer-management-protocol-mac.cc	2024-02-09 14:44:08.357793300 -0800
@@ -28,6 +28,7 @@
 #include "ns3/log.h"
 #include "ns3/mesh-information-element-vector.h"
 #include "ns3/mesh-wifi-interface-mac.h"
+#include "ns3/mgt-action-headers.h"
 #include "ns3/simulator.h"
 #include "ns3/wifi-mpdu.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/mesh/model/flame/flame-rtable.cc ns-3.41/src/mesh/model/flame/flame-rtable.cc
--- ns-3.40/src/mesh/model/flame/flame-rtable.cc	2023-09-27 13:30:37.834839600 -0700
+++ ns-3.41/src/mesh/model/flame/flame-rtable.cc	2024-02-09 14:44:08.357793300 -0800
@@ -98,7 +98,7 @@
     {
         return LookupResult();
     }
-    if ((i->second.whenExpire < Simulator::Now()))
+    if (i->second.whenExpire < Simulator::Now())
     {
         NS_LOG_DEBUG("Route has expired, sorry.");
         m_routes.erase(i);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/mesh/model/mesh-information-element-vector.cc ns-3.41/src/mesh/model/mesh-information-element-vector.cc
--- ns-3.40/src/mesh/model/mesh-information-element-vector.cc	2023-09-27 13:30:37.834839600 -0700
+++ ns-3.41/src/mesh/model/mesh-information-element-vector.cc	2024-02-09 14:44:08.357793300 -0800
@@ -202,7 +202,7 @@
     {
         if ((*i)->ElementId() == id)
         {
-            return (*i);
+            return *i;
         }
     }
     return nullptr;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/mesh/model/mesh-point-device.cc ns-3.41/src/mesh/model/mesh-point-device.cc
--- ns-3.40/src/mesh/model/mesh-point-device.cc	2023-09-27 13:30:37.834839600 -0700
+++ ns-3.41/src/mesh/model/mesh-point-device.cc	2024-02-09 14:44:08.357793300 -0800
@@ -174,16 +174,16 @@
 }
 
 void
-MeshPointDevice::Forward(Ptr<NetDevice> inport,
+MeshPointDevice::Forward(Ptr<NetDevice> incomingPort,
                          Ptr<const Packet> packet,
                          uint16_t protocol,
                          const Mac48Address src,
                          const Mac48Address dst)
 {
-    NS_LOG_FUNCTION(this << inport << packet << protocol << src << dst);
+    NS_LOG_FUNCTION(this << incomingPort << packet << protocol << src << dst);
     // pass through routing protocol
     NS_LOG_DEBUG("Forwarding from " << src << " to " << dst << " at " << m_address);
-    bool result = m_routingProtocol->RequestRoute(inport->GetIfIndex(),
+    bool result = m_routingProtocol->RequestRoute(incomingPort->GetIfIndex(),
                                                   src,
                                                   dst,
                                                   packet,
@@ -402,7 +402,7 @@
     {
         if ((*i)->GetIfIndex() == n)
         {
-            return (*i);
+            return *i;
         }
     }
     NS_FATAL_ERROR("Mesh point interface is not found by index");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/mobility/examples/reference-point-group-mobility-example.cc ns-3.41/src/mobility/examples/reference-point-group-mobility-example.cc
--- ns-3.40/src/mobility/examples/reference-point-group-mobility-example.cc	2023-09-27 13:30:37.838839500 -0700
+++ ns-3.41/src/mobility/examples/reference-point-group-mobility-example.cc	2024-02-09 14:44:08.365793500 -0800
@@ -33,7 +33,7 @@
  * and different child mobility models.
  *
  * There is no node associated with the parent (reference) model.
- * Instead, all nodes are associated with a hiearchical mobility model
+ * Instead, all nodes are associated with a hierarchical mobility model
  * containing both the parent and child models, and the position of
  * the node is the vector sum of these parent and child positions.
  *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/mobility/helper/ns2-mobility-helper.cc ns-3.41/src/mobility/helper/ns2-mobility-helper.cc
--- ns-3.40/src/mobility/helper/ns2-mobility-helper.cc	2023-09-27 13:30:37.838839500 -0700
+++ ns-3.41/src/mobility/helper/ns2-mobility-helper.cc	2024-02-09 14:44:08.365793500 -0800
@@ -854,7 +854,7 @@
     position.y = model->GetPosition().y;
     position.z = model->GetPosition().z;
 
-    // Chedule next positions
+    // Schedule next positions
     Simulator::Schedule(Seconds(at), &ConstantVelocityMobilityModel::SetPosition, model, position);
 
     return position;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/mobility/model/box.cc ns-3.41/src/mobility/model/box.cc
--- ns-3.40/src/mobility/model/box.cc	2023-09-27 13:30:37.838839500 -0700
+++ ns-3.41/src/mobility/model/box.cc	2024-02-09 14:44:08.365793500 -0800
@@ -145,7 +145,7 @@
 {
     // If any of the position falls inside the box,
     // return true.
-    if ((IsInside(l1) || IsInside(l2)))
+    if (IsInside(l1) || IsInside(l2))
     {
         return true;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/mobility/model/position-allocator.cc ns-3.41/src/mobility/model/position-allocator.cc
--- ns-3.40/src/mobility/model/position-allocator.cc	2023-09-27 13:30:37.842839700 -0700
+++ ns-3.41/src/mobility/model/position-allocator.cc	2024-02-09 14:44:08.365793500 -0800
@@ -185,7 +185,7 @@
             .AddAttribute("LayoutType",
                           "The type of layout.",
                           EnumValue(ROW_FIRST),
-                          MakeEnumAccessor(&GridPositionAllocator::m_layoutType),
+                          MakeEnumAccessor<LayoutType>(&GridPositionAllocator::m_layoutType),
                           MakeEnumChecker(ROW_FIRST, "RowFirst", COLUMN_FIRST, "ColumnFirst"));
     return tid;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/mobility/model/position-allocator.h ns-3.41/src/mobility/model/position-allocator.h
--- ns-3.40/src/mobility/model/position-allocator.h	2023-09-27 13:30:37.842839700 -0700
+++ ns-3.41/src/mobility/model/position-allocator.h	2024-02-09 14:44:08.365793500 -0800
@@ -370,7 +370,7 @@
  *
  * \note using UniformDiscPositionAllocator is not equivalent to using
  * a RandomDiscPositionAllocator with a uniformly-distributed radius,
- * since doing that would results in a point distribution which is
+ * since doing that would result in a point distribution which is
  * more dense towards the center of the disc.
  */
 class UniformDiscPositionAllocator : public PositionAllocator
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/mobility/model/random-walk-2d-mobility-model.cc ns-3.41/src/mobility/model/random-walk-2d-mobility-model.cc
--- ns-3.40/src/mobility/model/random-walk-2d-mobility-model.cc	2023-09-27 13:30:37.842839700 -0700
+++ ns-3.41/src/mobility/model/random-walk-2d-mobility-model.cc	2024-02-09 14:44:08.365793500 -0800
@@ -61,7 +61,8 @@
                           "The mode indicates the condition used to "
                           "change the current speed and direction",
                           EnumValue(RandomWalk2dMobilityModel::MODE_DISTANCE),
-                          MakeEnumAccessor(&RandomWalk2dMobilityModel::m_mode),
+                          MakeEnumAccessor<RandomWalk2dMobilityModel::Mode>(
+                              &RandomWalk2dMobilityModel::m_mode),
                           MakeEnumChecker(RandomWalk2dMobilityModel::MODE_DISTANCE,
                                           "Distance",
                                           RandomWalk2dMobilityModel::MODE_TIME,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/mobility/test/ns2-mobility-helper-test-suite.cc ns-3.41/src/mobility/test/ns2-mobility-helper-test-suite.cc
--- ns-3.40/src/mobility/test/ns2-mobility-helper-test-suite.cc	2023-09-27 13:30:37.842839700 -0700
+++ ns-3.41/src/mobility/test/ns2-mobility-helper-test-suite.cc	2024-02-09 14:44:08.365793500 -0800
@@ -118,7 +118,7 @@
          */
         bool operator<(const ReferencePoint& o) const
         {
-            return (time < o.time);
+            return time < o.time;
         }
     };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/mpi/CMakeLists.txt ns-3.41/src/mpi/CMakeLists.txt
--- ns-3.40/src/mpi/CMakeLists.txt	2023-09-27 13:30:37.842839700 -0700
+++ ns-3.41/src/mpi/CMakeLists.txt	2024-02-09 14:44:08.369793400 -0800
@@ -21,9 +21,7 @@
     model/mpi-interface.h
     model/mpi-receiver.h
     model/parallel-communication-interface.h
-  LIBRARIES_TO_LINK
-    ${libcore}
-    ${libnetwork}
-    ${MPI_CXX_LIBRARIES}
+  LIBRARIES_TO_LINK ${libnetwork}
+                    ${MPI_CXX_LIBRARIES}
   TEST_SOURCES ${example_as_test_suite}
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/mpi/model/distributed-simulator-impl.cc ns-3.41/src/mpi/model/distributed-simulator-impl.cc
--- ns-3.40/src/mpi/model/distributed-simulator-impl.cc	2023-09-27 13:30:37.842839700 -0700
+++ ns-3.41/src/mpi/model/distributed-simulator-impl.cc	2024-02-09 14:44:08.369793400 -0800
@@ -464,12 +464,12 @@
     m_stop = true;
 }
 
-void
+EventId
 DistributedSimulatorImpl::Stop(const Time& delay)
 {
     NS_LOG_FUNCTION(this << delay.GetTimeStep());
 
-    Simulator::Schedule(delay, &Simulator::Stop);
+    return Simulator::Schedule(delay, &Simulator::Stop);
 }
 
 //
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/mpi/model/distributed-simulator-impl.h ns-3.41/src/mpi/model/distributed-simulator-impl.h
--- ns-3.40/src/mpi/model/distributed-simulator-impl.h	2023-09-27 13:30:37.842839700 -0700
+++ ns-3.41/src/mpi/model/distributed-simulator-impl.h	2024-02-09 14:44:08.369793400 -0800
@@ -122,7 +122,7 @@
     void Destroy() override;
     bool IsFinished() const override;
     void Stop() override;
-    void Stop(const Time& delay) override;
+    EventId Stop(const Time& delay) override;
     EventId Schedule(const Time& delay, EventImpl* event) override;
     void ScheduleWithContext(uint32_t context, const Time& delay, EventImpl* event) override;
     EventId ScheduleNow(EventImpl* event) override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/mpi/model/granted-time-window-mpi-interface.cc ns-3.41/src/mpi/model/granted-time-window-mpi-interface.cc
--- ns-3.40/src/mpi/model/granted-time-window-mpi-interface.cc	2023-09-27 13:30:37.842839700 -0700
+++ ns-3.41/src/mpi/model/granted-time-window-mpi-interface.cc	2024-02-09 14:44:08.369793400 -0800
@@ -52,7 +52,7 @@
 SentBuffer::SentBuffer()
 {
     m_buffer = nullptr;
-    m_request = nullptr;
+    m_request = MPI_REQUEST_NULL;
 }
 
 SentBuffer::~SentBuffer()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/mpi/model/null-message-mpi-interface.cc ns-3.41/src/mpi/model/null-message-mpi-interface.cc
--- ns-3.40/src/mpi/model/null-message-mpi-interface.cc	2023-09-27 13:30:37.842839700 -0700
+++ ns-3.41/src/mpi/model/null-message-mpi-interface.cc	2024-02-09 14:44:08.369793400 -0800
@@ -97,7 +97,7 @@
 NullMessageSentBuffer::NullMessageSentBuffer()
 {
     m_buffer = nullptr;
-    m_request = nullptr;
+    m_request = MPI_REQUEST_NULL;
 }
 
 NullMessageSentBuffer::~NullMessageSentBuffer()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/mpi/model/null-message-simulator-impl.cc ns-3.41/src/mpi/model/null-message-simulator-impl.cc
--- ns-3.40/src/mpi/model/null-message-simulator-impl.cc	2023-09-27 13:30:37.842839700 -0700
+++ ns-3.41/src/mpi/model/null-message-simulator-impl.cc	2024-02-09 14:44:08.369793400 -0800
@@ -382,12 +382,12 @@
     m_stop = true;
 }
 
-void
+EventId
 NullMessageSimulatorImpl::Stop(const Time& delay)
 {
     NS_LOG_FUNCTION(this << delay.GetTimeStep());
 
-    Simulator::Schedule(delay, &Simulator::Stop);
+    return Simulator::Schedule(delay, &Simulator::Stop);
 }
 
 //
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/mpi/model/null-message-simulator-impl.h ns-3.41/src/mpi/model/null-message-simulator-impl.h
--- ns-3.40/src/mpi/model/null-message-simulator-impl.h	2023-09-27 13:30:37.842839700 -0700
+++ ns-3.41/src/mpi/model/null-message-simulator-impl.h	2024-02-09 14:44:08.369793400 -0800
@@ -66,7 +66,7 @@
     void Destroy() override;
     bool IsFinished() const override;
     void Stop() override;
-    void Stop(const Time& delay) override;
+    EventId Stop(const Time& delay) override;
     EventId Schedule(const Time& delay, EventImpl* event) override;
     void ScheduleWithContext(uint32_t context, const Time& delay, EventImpl* event) override;
     EventId ScheduleNow(EventImpl* event) override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/netanim/CMakeLists.txt ns-3.41/src/netanim/CMakeLists.txt
--- ns-3.40/src/netanim/CMakeLists.txt	2023-09-27 13:30:37.842839700 -0700
+++ ns-3.41/src/netanim/CMakeLists.txt	2024-02-09 14:44:08.369793400 -0800
@@ -3,15 +3,10 @@
   SOURCE_FILES model/animation-interface.cc
   HEADER_FILES model/animation-interface.h
   LIBRARIES_TO_LINK
-    ${libinternet}
-    ${libmobility}
     ${libwimax}
     ${libwifi}
-    ${libcsma}
     ${liblte}
     ${libuan}
-    ${libenergy}
     ${liblr-wpan}
-    ${libpoint-to-point-layout}
   TEST_SOURCES test/netanim-test.cc
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/netanim/model/animation-interface.cc ns-3.41/src/netanim/model/animation-interface.cc
--- ns-3.40/src/netanim/model/animation-interface.cc	2023-09-27 13:30:37.850839600 -0700
+++ ns-3.41/src/netanim/model/animation-interface.cc	2024-02-09 14:44:08.397793500 -0800
@@ -15,7 +15,7 @@
  * Author: George F. Riley<riley@ece.gatech.edu>
  * Modified by: John Abraham <john.abraham@gatech.edu>
  * Contributions: Eugene Kalishenko <ydginster@gmail.com> (Open Source and Linux Laboratory
- * http://dev.osll.ru/) Tommaso Pecorella <tommaso.pecorella@unifi.it> Pavel Vasilyev
+ * http://wiki.osll.ru/doku.php/start) Tommaso Pecorella <tommaso.pecorella@unifi.it> Pavel Vasilyev
  * <pavel.vasilyev@sredasolutions.com>
  */
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/netanim/model/animation-interface.h ns-3.41/src/netanim/model/animation-interface.h
--- ns-3.40/src/netanim/model/animation-interface.h	2023-09-27 13:30:37.850839600 -0700
+++ ns-3.41/src/netanim/model/animation-interface.h	2024-02-09 14:44:08.397793500 -0800
@@ -15,7 +15,7 @@
  * Author: George F. Riley<riley@ece.gatech.edu>
  * Author: John Abraham <john.abraham@gatech.edu>
  * Contributions: Eugene Kalishenko <ydginster@gmail.com> (Open Source and Linux Laboratory
- * http://dev.osll.ru/)
+ * http://wiki.osll.ru/doku.php/start)
  */
 
 // Interface between ns3 and the network animator
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/netanim/_required_netanim_version.py ns-3.41/src/netanim/_required_netanim_version.py
--- ns-3.40/src/netanim/_required_netanim_version.py	2023-09-27 13:30:37.842839700 -0700
+++ ns-3.41/src/netanim/_required_netanim_version.py	2024-02-09 14:44:08.369793400 -0800
@@ -6,4 +6,4 @@
 # on 'git describe --tags' command.  Example, if the latest release was 3.108,
 # and 'git describe --tags' reports "netanim-3.108-6-g8e7c0a9", then write the
 # version string below as 'netanim-3.108.post6+ng8e7c0a9'
-__required_netanim_version__ = 'netanim-3.109'
+__required_netanim_version__ = "netanim-3.109"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/netanim/test/netanim-test.cc ns-3.41/src/netanim/test/netanim-test.cc
--- ns-3.40/src/netanim/test/netanim-test.cc	2023-09-27 13:30:37.850839600 -0700
+++ ns-3.41/src/netanim/test/netanim-test.cc	2024-02-09 14:44:08.397793500 -0800
@@ -14,7 +14,7 @@
  *
  * Author: John Abraham <john.abraham@gatech.edu>
  * Contributions: Eugene Kalishenko <ydginster@gmail.com> (Open Source and Linux Laboratory
- * http://dev.osll.ru/)
+ * http://wiki.osll.ru/doku.php/start)
  */
 
 #include "unistd.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/CMakeLists.txt ns-3.41/src/network/CMakeLists.txt
--- ns-3.40/src/network/CMakeLists.txt	2023-09-27 13:30:37.850839600 -0700
+++ ns-3.41/src/network/CMakeLists.txt	2024-02-09 14:44:08.397793500 -0800
@@ -154,8 +154,7 @@
   LIBNAME network
   SOURCE_FILES ${source_files}
   HEADER_FILES ${header_files}
-  LIBRARIES_TO_LINK ${libcore}
-                    ${libstats}
+  LIBRARIES_TO_LINK ${libstats}
   TEST_SOURCES
     test/bit-serializer-test.cc
     test/buffer-test.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/model/buffer.cc ns-3.41/src/network/model/buffer.cc
--- ns-3.40/src/network/model/buffer.cc	2023-09-27 13:30:37.850839600 -0700
+++ ns-3.41/src/network/model/buffer.cc	2024-02-09 14:44:08.401793700 -0800
@@ -586,66 +586,60 @@
     uint32_t size = 0;
 
     // Add the zero data length
-    if (size + 4 <= maxSize)
-    {
-        size += 4;
-        *p++ = m_zeroAreaEnd - m_zeroAreaStart;
-    }
-    else
+    size += 4;
+
+    if (size > maxSize)
     {
         return 0;
     }
 
+    *p++ = m_zeroAreaEnd - m_zeroAreaStart;
+
     // Add the length of actual start data
-    uint32_t dataStartLength = m_zeroAreaStart - m_start;
-    if (size + 4 <= maxSize)
-    {
-        size += 4;
-        *p++ = dataStartLength;
-    }
-    else
+    size += 4;
+
+    if (size > maxSize)
     {
         return 0;
     }
 
+    uint32_t dataStartLength = m_zeroAreaStart - m_start;
+    *p++ = dataStartLength;
+
     // Add the actual data
-    if (size + ((dataStartLength + 3) & (~3)) <= maxSize)
-    {
-        size += (dataStartLength + 3) & (~3);
-        memcpy(p, m_data->m_data + m_start, dataStartLength);
-        p += (((dataStartLength + 3) & (~3)) / 4); // Advance p, insuring 4 byte boundary
-    }
-    else
+    size += (dataStartLength + 3) & (~3);
+
+    if (size > maxSize)
     {
         return 0;
     }
 
+    memcpy(p, m_data->m_data + m_start, dataStartLength);
+    p += (((dataStartLength + 3) & (~3)) / 4); // Advance p, insuring 4 byte boundary
+
     // Add the length of the actual end data
-    uint32_t dataEndLength = m_end - m_zeroAreaEnd;
-    if (size + 4 <= maxSize)
-    {
-        size += 4;
-        *p++ = dataEndLength;
-    }
-    else
+    size += 4;
+
+    if (size > maxSize)
     {
         return 0;
     }
 
+    uint32_t dataEndLength = m_end - m_zeroAreaEnd;
+    *p++ = dataEndLength;
+
     // Add the actual data
-    if (size + ((dataEndLength + 3) & (~3)) <= maxSize)
-    {
-        // The following line is unnecessary.
-        // size += (dataEndLength + 3) & (~3);
-        memcpy(p, m_data->m_data + m_zeroAreaStart, dataEndLength);
-        // The following line is unnecessary.
-        // p += (((dataEndLength + 3) & (~3))/4); // Advance p, insuring 4 byte boundary
-    }
-    else
+    size += (dataEndLength + 3) & (~3);
+
+    if (size > maxSize)
     {
         return 0;
     }
 
+    memcpy(p, m_data->m_data + m_zeroAreaStart, dataEndLength);
+    // The following line is unnecessary.
+    // p += (((dataEndLength + 3) & (~3))/4); // Advance p, insuring 4 byte boundary
+
     // Serialized everything successfully
     return 1;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/model/byte-tag-list.cc ns-3.41/src/network/model/byte-tag-list.cc
--- ns-3.40/src/network/model/byte-tag-list.cc	2023-09-27 13:30:37.850839600 -0700
+++ ns-3.41/src/network/model/byte-tag-list.cc	2024-02-09 14:44:08.401793700 -0800
@@ -470,19 +470,16 @@
     uint32_t* p = buffer;
     uint32_t size = 0;
 
-    uint32_t* numberOfTags = nullptr;
+    size += 4;
 
-    if (size + 4 <= maxSize)
-    {
-        numberOfTags = p;
-        *p++ = 0;
-        size += 4;
-    }
-    else
+    if (size > maxSize)
     {
         return 0;
     }
 
+    uint32_t* numberOfTags = p;
+    *p++ = 0;
+
     ByteTagList::Iterator i = BeginAll();
     while (i.HasNext())
     {
@@ -492,62 +489,56 @@
 
         // ensure size is multiple of 4 bytes for 4 byte boundaries
         uint32_t hashSize = (sizeof(TypeId::hash_t) + 3) & (~3);
-        if (size + hashSize <= maxSize)
-        {
-            TypeId::hash_t tid = item.tid.GetHash();
-            memcpy(p, &tid, sizeof(TypeId::hash_t));
-            p += hashSize / 4;
-            size += hashSize;
-        }
-        else
+        size += hashSize;
+
+        if (size > maxSize)
         {
             return 0;
         }
 
-        if (size + 4 <= maxSize)
-        {
-            *p++ = item.size;
-            size += 4;
-        }
-        else
+        TypeId::hash_t tid = item.tid.GetHash();
+        memcpy(p, &tid, sizeof(TypeId::hash_t));
+        p += hashSize / 4;
+
+        size += 4;
+
+        if (size > maxSize)
         {
             return 0;
         }
 
-        if (size + 4 <= maxSize)
-        {
-            *p++ = item.start;
-            size += 4;
-        }
-        else
+        *p++ = item.size;
+
+        size += 4;
+
+        if (size > maxSize)
         {
             return 0;
         }
 
-        if (size + 4 <= maxSize)
-        {
-            *p++ = item.end;
-            size += 4;
-        }
-        else
+        *p++ = item.start;
+
+        size += 4;
+
+        if (size > maxSize)
         {
             return 0;
         }
 
+        *p++ = item.end;
+
         // ensure size is multiple of 4 bytes for 4 byte boundaries
         uint32_t tagWordSize = (item.size + 3) & (~3);
+        size += tagWordSize;
 
-        if (size + tagWordSize <= maxSize)
-        {
-            item.buf.Read(reinterpret_cast<uint8_t*>(p), item.size);
-            size += tagWordSize;
-            p += tagWordSize / 4;
-        }
-        else
+        if (size > maxSize)
         {
             return 0;
         }
 
+        item.buf.Read(reinterpret_cast<uint8_t*>(p), item.size);
+        p += tagWordSize / 4;
+
         (*numberOfTags)++;
     }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/model/channel-list.cc ns-3.41/src/network/model/channel-list.cc
--- ns-3.40/src/network/model/channel-list.cc	2023-09-27 13:30:37.850839600 -0700
+++ ns-3.41/src/network/model/channel-list.cc	2024-02-09 14:44:08.401793700 -0800
@@ -178,6 +178,7 @@
     NS_LOG_FUNCTION(this << channel);
     uint32_t index = m_channels.size();
     m_channels.push_back(channel);
+    Simulator::Schedule(TimeStep(0), &Channel::Initialize, channel);
     return index;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/model/nix-vector.cc ns-3.41/src/network/model/nix-vector.cc
--- ns-3.40/src/network/model/nix-vector.cc	2023-09-27 13:30:37.854839600 -0700
+++ ns-3.41/src/network/model/nix-vector.cc	2024-02-09 14:44:08.401793700 -0800
@@ -282,7 +282,7 @@
         m_epoch = *p++;
     }
 
-    return (GetSerializedSize());
+    return GetSerializedSize();
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/network/model/packet.cc ns-3.41/src/network/model/packet.cc
--- ns-3.40/src/network/model/packet.cc	2023-09-27 13:30:37.854839600 -0700
+++ ns-3.41/src/network/model/packet.cc	2024-02-09 14:44:08.421793700 -0800
@@ -669,149 +669,130 @@
     if (m_nixVector)
     {
         uint32_t nixSize = m_nixVector->GetSerializedSize();
-        if (size + nixSize <= maxSize)
+        size += nixSize;
+        if (size > maxSize)
         {
-            // put the total length of nix-vector in the
-            // buffer. this includes 4-bytes for total
-            // length itself
-            *p++ = nixSize + 4;
-            size += nixSize;
-
-            // serialize the nix-vector
-            uint32_t serialized = m_nixVector->Serialize(p, nixSize);
-            if (serialized)
-            {
-                // increment p by nixSize bytes
-                // ensuring 4-byte boundary
-                p += ((nixSize + 3) & (~3)) / 4;
-            }
-            else
-            {
-                return 0;
-            }
+            return 0;
         }
-        else
+
+        // put the total length of nix-vector in the
+        // buffer. this includes 4-bytes for total
+        // length itself
+        *p++ = nixSize + 4;
+
+        // serialize the nix-vector
+        uint32_t serialized = m_nixVector->Serialize(p, nixSize);
+        if (!serialized)
         {
             return 0;
         }
+
+        // increment p by nixSize bytes
+        // ensuring 4-byte boundary
+        p += ((nixSize + 3) & (~3)) / 4;
     }
     else
     {
         // no nix vector, set zero length,
         // ie 4-bytes, since it must include
         // length for itself
-        if (size + 4 <= maxSize)
-        {
-            size += 4;
-            *p++ = 4;
-        }
-        else
+        size += 4;
+        if (size > maxSize)
         {
             return 0;
         }
+
+        *p++ = 4;
     }
 
     // Serialize byte tag list
     uint32_t byteTagSize = m_byteTagList.GetSerializedSize();
-    if (size + byteTagSize <= maxSize)
+    size += byteTagSize;
+    if (size > maxSize)
     {
-        // put the total length of byte tag list in the
-        // buffer. this includes 4-bytes for total
-        // length itself
-        *p++ = byteTagSize + 4;
-        size += byteTagSize;
-
-        // serialize the byte tag list
-        uint32_t serialized = m_byteTagList.Serialize(p, byteTagSize);
-        if (serialized)
-        {
-            // increment p by byteTagSize bytes
-            // ensuring 4-byte boundary
-            p += ((byteTagSize + 3) & (~3)) / 4;
-        }
-        else
-        {
-            return 0;
-        }
+        return 0;
     }
-    else
+
+    // put the total length of byte tag list in the
+    // buffer. this includes 4-bytes for total
+    // length itself
+    *p++ = byteTagSize + 4;
+
+    // serialize the byte tag list
+    uint32_t serialized = m_byteTagList.Serialize(p, byteTagSize);
+    if (!serialized)
     {
         return 0;
     }
 
+    // increment p by byteTagSize bytes
+    // ensuring 4-byte boundary
+    p += ((byteTagSize + 3) & (~3)) / 4;
+
     // Serialize packet tag list
     uint32_t packetTagSize = m_packetTagList.GetSerializedSize();
-    if (size + packetTagSize <= maxSize)
+    size += packetTagSize;
+    if (size > maxSize)
     {
-        // put the total length of packet tag list in the
-        // buffer. this includes 4-bytes for total
-        // length itself
-        *p++ = packetTagSize + 4;
-        size += packetTagSize;
-
-        // serialize the packet tag list
-        uint32_t serialized = m_packetTagList.Serialize(p, packetTagSize);
-        if (serialized)
-        {
-            // increment p by packetTagSize bytes
-            // ensuring 4-byte boundary
-            p += ((packetTagSize + 3) & (~3)) / 4;
-        }
-        else
-        {
-            return 0;
-        }
+        return 0;
     }
-    else
+
+    // put the total length of packet tag list in the
+    // buffer. this includes 4-bytes for total
+    // length itself
+    *p++ = packetTagSize + 4;
+
+    // serialize the packet tag list
+    serialized = m_packetTagList.Serialize(p, packetTagSize);
+    if (!serialized)
     {
         return 0;
     }
 
+    // increment p by packetTagSize bytes
+    // ensuring 4-byte boundary
+    p += ((packetTagSize + 3) & (~3)) / 4;
+
     // Serialize Metadata
     uint32_t metaSize = m_metadata.GetSerializedSize();
-    if (size + metaSize <= maxSize)
+    size += metaSize;
+    if (size > maxSize)
     {
-        // put the total length of metadata in the
-        // buffer. this includes 4-bytes for total
-        // length itself
-        *p++ = metaSize + 4;
-        size += metaSize;
-
-        // serialize the metadata
-        uint32_t serialized = m_metadata.Serialize(reinterpret_cast<uint8_t*>(p), metaSize);
-        if (serialized)
-        {
-            // increment p by metaSize bytes
-            // ensuring 4-byte boundary
-            p += ((metaSize + 3) & (~3)) / 4;
-        }
-        else
-        {
-            return 0;
-        }
+        return 0;
     }
-    else
+
+    // put the total length of metadata in the
+    // buffer. this includes 4-bytes for total
+    // length itself
+    *p++ = metaSize + 4;
+
+    // serialize the metadata
+    serialized = m_metadata.Serialize(reinterpret_cast<uint8_t*>(p), metaSize);
+    if (!serialized)
     {
         return 0;
     }
 
+    // increment p by metaSize bytes
+    // ensuring 4-byte boundary
+    p += ((metaSize + 3) & (~3)) / 4;
+
     // Serialize the packet contents
     uint32_t bufSize = m_buffer.GetSerializedSize();
-    if (size + bufSize <= maxSize)
+    size += bufSize;
+    if (size > maxSize)
     {
-        // put the total length of the buffer in the
-        // buffer. this includes 4-bytes for total
-        // length itself
-        *p++ = bufSize + 4;
-
-        // serialize the buffer
-        uint32_t serialized = m_buffer.Serialize(reinterpret_cast<uint8_t*>(p), bufSize);
-        if (!serialized)
-        {
-            return 0;
-        }
+        return 0;
     }
-    else
+
+    // put the total length of the buffer in the
+    // buffer. this includes 4-bytes for total
+    // length itself
+    *p++ = bufSize + 4;
+
+    // serialize the buffer
+    serialized = m_buffer.Serialize(reinterpret_cast<uint8_t*>(p), bufSize);
+    if (!serialized)
     {
         return 0;
     }
